<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>
  </head>
  <body>
    <div class="container">
      <h2 style="text-align: center;">Danh sách người dùng</h2>
      <table
        id="user-table"
        class="table table-bordered table-striped table-hover"
      >
        <thead>
          <tr>
            <th>Mã người dùng</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Country</th>
            <th>Subject</th>
            <th>Customer Type</th>
            <th>Register Status</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>
  </body>
</html>

<script>
  "use strict";
  $(document).ready(function () {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gDATA_COLUMN = [
        "id",
        "firstname",
        "lastname",
        "country",
        "subject",
        "customerType",
        "registerStatus",
        "action",
    ];
    const gUSER_ID = 0;
    const gFIRST_NAME = 1;
    const gLAST_NAME = 2;
    const gCOUNTRY = 3;
    const gSUBJECT = 4;
    const gCUSTOMER_TYPE = 5;
    const gREGISTER_STATUS = 6;
    const gACTION = 7;

    $("#user-table").DataTable({
        columns: [
            {"data": gDATA_COLUMN[gUSER_ID]},
            {"data": gDATA_COLUMN[gFIRST_NAME]},
            {"data": gDATA_COLUMN[gLAST_NAME]},
            {"data": gDATA_COLUMN[gCOUNTRY]},
            {"data": gDATA_COLUMN[gSUBJECT]},
            {"data": gDATA_COLUMN[gCUSTOMER_TYPE]},
            {"data": gDATA_COLUMN[gREGISTER_STATUS]},
            {"data": gDATA_COLUMN[gACTION]},
        ],
        columnDefs: [
            {
                target: gACTION,
                defaultContent: `<button class = "btn btn-success btn-detail"> Chi tiết </button>`,
            }
        ]
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    $(document).on("click", ".btn-detail", function() {
        onBtnDetailClick(this);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm được gọi khi load trang
    function onPageLoading() {
      "use strict";
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
        type: "GET",
        dataType: "json", // added data type
        success: function (res) {
            loadDataToTable(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load dữ liệu vào table
    function loadDataToTable(paramObjectUsers) {
        var vTable = $("#user-table").DataTable();
        vTable.clear();
        vTable.rows.add(paramObjectUsers);
        vTable.draw();
    }

    //hàm xử lý sự kiện bấm nút 
    function onBtnDetailClick(paramElement) {
        var vRowClick = $(paramElement).parents("tr");
        var vTable = $("#user-table").DataTable();
        var vDataRow = vTable.row(vRowClick).data();

        console.log("User Id: " + vDataRow.id);
        console.log("User first name: " + vDataRow.firstname);
        console.log("User last name: " + vDataRow.lastname);
        console.log("User country: " + vDataRow.country);
        console.log("User subject: " + vDataRow.subject);
        console.log("User customer type: " + vDataRow.customerType);
        console.log("User register status: " + vDataRow.registerStatus);
    }
  });
</script>
